Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_genMealy.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_genMealy.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_genMealy.cpp	(revision 78)
@@ -78,15 +78,16 @@
 		    PORT_WRITE(out_EXECUTE_UNIT_IN_OPERATION             [dest], PORT_READ(in_READ_UNIT_OUT_OPERATION             [i]));
 		    PORT_WRITE(out_EXECUTE_UNIT_IN_TYPE                  [dest], PORT_READ(in_READ_UNIT_OUT_TYPE                  [i]));
+		    PORT_WRITE(out_EXECUTE_UNIT_IN_HAS_IMMEDIAT          [dest], PORT_READ(in_READ_UNIT_OUT_HAS_IMMEDIAT          [i]));
+		    PORT_WRITE(out_EXECUTE_UNIT_IN_DATA_RC               [dest], PORT_READ(in_READ_UNIT_OUT_DATA_RC               [i]));
+		    PORT_WRITE(out_EXECUTE_UNIT_IN_WRITE_RD              [dest], PORT_READ(in_READ_UNIT_OUT_WRITE_RD              [i]));
+		    PORT_WRITE(out_EXECUTE_UNIT_IN_WRITE_RE              [dest], PORT_READ(in_READ_UNIT_OUT_WRITE_RE              [i]));
+		    PORT_WRITE(out_EXECUTE_UNIT_IN_NUM_REG_RE            [dest], PORT_READ(in_READ_UNIT_OUT_NUM_REG_RE            [i]));
 		    PORT_WRITE(out_EXECUTE_UNIT_IN_STORE_QUEUE_PTR_WRITE [dest], PORT_READ(in_READ_UNIT_OUT_STORE_QUEUE_PTR_WRITE [i]));
+		    if (_param->_have_port_load_queue_ptr)
 		    PORT_WRITE(out_EXECUTE_UNIT_IN_LOAD_QUEUE_PTR_WRITE  [dest], PORT_READ(in_READ_UNIT_OUT_LOAD_QUEUE_PTR_WRITE  [i]));
-		    PORT_WRITE(out_EXECUTE_UNIT_IN_HAS_IMMEDIAT          [dest], PORT_READ(in_READ_UNIT_OUT_HAS_IMMEDIAT          [i]));
 		    PORT_WRITE(out_EXECUTE_UNIT_IN_IMMEDIAT              [dest], PORT_READ(in_READ_UNIT_OUT_IMMEDIAT              [i]));
 		    PORT_WRITE(out_EXECUTE_UNIT_IN_DATA_RA               [dest], PORT_READ(in_READ_UNIT_OUT_DATA_RA               [i]));
 		    PORT_WRITE(out_EXECUTE_UNIT_IN_DATA_RB               [dest], PORT_READ(in_READ_UNIT_OUT_DATA_RB               [i]));
-		    PORT_WRITE(out_EXECUTE_UNIT_IN_DATA_RC               [dest], PORT_READ(in_READ_UNIT_OUT_DATA_RC               [i]));
-		    PORT_WRITE(out_EXECUTE_UNIT_IN_WRITE_RD              [dest], PORT_READ(in_READ_UNIT_OUT_WRITE_RD              [i]));
 		    PORT_WRITE(out_EXECUTE_UNIT_IN_NUM_REG_RD            [dest], PORT_READ(in_READ_UNIT_OUT_NUM_REG_RD            [i]));
-		    PORT_WRITE(out_EXECUTE_UNIT_IN_WRITE_RE              [dest], PORT_READ(in_READ_UNIT_OUT_WRITE_RE              [i]));
-		    PORT_WRITE(out_EXECUTE_UNIT_IN_NUM_REG_RE            [dest], PORT_READ(in_READ_UNIT_OUT_NUM_REG_RE            [i]));
 		  }
 	      }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/include/Parameters.h	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/include/Parameters.h	(revision 78)
@@ -50,5 +50,5 @@
   public : ~Parameters () ;
 
-  public :        std::string   msg_error  (void);
+  public :        Parameters_test msg_error  (void);
 
   public :        std::string   print      (uint32_t depth);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Parameters_msg_error.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Parameters_msg_error.cpp	(revision 78)
@@ -21,13 +21,13 @@
 #undef  FUNCTION
 #define FUNCTION "Register_unit_Glue::msg_error"
-  std::string Parameters::msg_error(void)
+  Parameters_test Parameters::msg_error(void)
   {
     log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
 
-    std::string msg = "";
-
-    return msg;
+    Parameters_test test("Register_unit_Glue");
 
     log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+
+    return test;
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/include/Parameters.h	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/include/Parameters.h	(revision 78)
@@ -79,5 +79,5 @@
   public : ~Parameters () ;
 
-  public :        std::string   msg_error  (void);
+  public :        Parameters_test msg_error  (void);
   public :        std::string   print      (uint32_t depth);
   public : friend std::ostream& operator<< (std::ostream& output_stream,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Parameters_msg_error.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Parameters_msg_error.cpp	(revision 78)
@@ -18,13 +18,13 @@
 #undef  FUNCTION
 #define FUNCTION "Register_unit::msg_error"
-  std::string Parameters::msg_error(void)
+  Parameters_test Parameters::msg_error(void)
   {
     log_printf(FUNC,Register_unit,FUNCTION,"Begin");
 
-    std::string msg = "";
-
-    return msg;
+    Parameters_test test("Register_unit");
 
     log_printf(FUNC,Register_unit,FUNCTION,"End");
+
+    return test;
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp	(revision 78)
@@ -240,5 +240,5 @@
 
 	    in_RETIRE_ROB_VAL            [i][j] = interface->set_signal_valack_in  (VAL);
-	    out_RETIRE_ROB_ACK            [i][j] = interface->set_signal_valack_out (ACK);
+	   out_RETIRE_ROB_ACK            [i][j] = interface->set_signal_valack_out (ACK);
 	    in_RETIRE_ROB_RD_OLD_USE     [i][j] = interface->set_signal_in <Tcontrol_t        > ("rd_old_use"    , 1);
 	    in_RETIRE_ROB_RD_OLD_NUM_REG [i][j] = interface->set_signal_in <Tgeneral_address_t> ("rd_old_num_reg", _param->_size_gpr_address);
@@ -470,4 +470,11 @@
 				   _name+"_glue",
 				   "out_CONST_1");
+
+	      _component->port_map(_name+"_glue",
+				   "out_CONST_1",
+				   name_component,
+				   "in_WRITE_"+toString(x)+"_DATA" );
+
+
 	      _component->port_map(name_component,
 				   "in_WRITE_"+toString(x++)+"_ADDRESS",
@@ -492,4 +499,8 @@
 				   "out_CONST_0"
 				   );
+	      _component->port_map( _name+"_glue",
+				    "out_CONST_0",
+				    name_component,
+				   "in_WRITE_"+toString(x)+"_DATA");
 
 	      _component->port_map(name_component,
@@ -515,4 +526,8 @@
 				   _name+"_glue",
 				   "out_CONST_0");
+	      _component->port_map(_name+"_glue",
+				   "out_CONST_0",
+				   name_component,
+				   "in_WRITE_"+toString(x)+"_DATA" );
 
 	      _component->port_map(name_component,
@@ -534,4 +549,9 @@
 				   _name+"_glue",
 				   "out_CONST_1"
+				   );
+	      _component->port_map(_name+"_glue",
+				   "out_CONST_1",
+				   name_component,
+				   "in_WRITE_"+toString(x)+"_DATA"
 				   );
 
@@ -651,4 +671,10 @@
 				   _name+"_glue",
 				   "out_CONST_1");
+	      _component->port_map(_name+"_glue",
+				   "out_CONST_1",
+				   name_component,
+				   "in_WRITE_"+toString(x)+"_DATA"
+				   );
+
 	      _component->port_map(name_component,
 				   "in_WRITE_"+toString(x++)+"_ADDRESS",
@@ -673,4 +699,9 @@
 				   "out_CONST_0"
 				   );
+	      _component->port_map( _name+"_glue",
+				    "out_CONST_0",
+				   name_component,
+				   "in_WRITE_"+toString(x)+"_DATA"
+				   );
 
 	      _component->port_map(name_component,
@@ -696,4 +727,9 @@
 				   _name+"_glue",
 				   "out_CONST_0");
+	      _component->port_map(_name+"_glue",
+				   "out_CONST_0",
+				   name_component,
+				   "in_WRITE_"+toString(x)+"_DATA"
+				   );
 
 	      _component->port_map(name_component,
@@ -715,4 +751,9 @@
 				   _name+"_glue",
 				   "out_CONST_1"
+				   );
+	      _component->port_map(_name+"_glue",
+				   "out_CONST_1",
+				   name_component,
+				   "in_WRITE_"+toString(x)+"_DATA"
 				   );
 
@@ -738,6 +779,6 @@
       _component->port_map(name_component,"in_CLOCK" , _name, "in_CLOCK" );
       _component->port_map(name_component,"in_NRESET", _name, "in_NRESET");
-      _component->port_map(name_component,"out_CONST_0");
-      _component->port_map(name_component,"out_CONST_1");
+//       _component->port_map(name_component,"out_CONST_0",_name,"out_CONST_0");
+//       _component->port_map(name_component,"out_CONST_1",_name,"out_CONST_1");
 
       for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/Makefile
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/Makefile	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/Makefile	(revision 78)
@@ -0,0 +1,30 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+LIBRARY				= $(Execute_loop_LIBRARY)
+
+DIR_LIBRARY			= $(Execute_loop_DIR_LIBRARY)
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_selftest
+
+library				: Execute_loop_library
+
+library_clean			: Execute_loop_library_clean
+
+include                         $(DIR_COMPONENT)/Makefile.deps
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.Synthesis
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/configuration.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/configuration.cfg	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/configuration.cfg	(revision 78)
@@ -0,0 +1,42 @@
+Execute_loop
+1	1	+1	# nb_read_unit                              
+1	1	+1	# nb_functionnal_unit                       
+1	1	+1	# nb_load_store_unit                        
+1	1	+1	# nb_write_unit                             
+1	1	+1	# nb_context                                
+1	1	+1	# nb_front_end                              
+1	1	+1	# nb_ooo_engine                             
+32	32	+1	# nb_packet                                 
+32	32	+1	# size_general_data                         
+2	2	+1	# size_special_data                         
+1	1	+1	# size_read_queue                            [0]    [read_unit]
+1	1	+1	# size_reservation_station                   [0]    [read_unit]
+1	1	+1	# nb_inst_retire                             [0]    [read_unit]
+2	2	+1	# size_store_queue                           [0]    [load_store_unit]
+1	1	+1	# size_load_queue                            [0]    [load_store_unit]
+1	1	+1	# size_speculative_access_queue              [0]    [load_store_unit]
+1	1	+1	# nb_port_check                              [0]    [load_store_unit]
+2	2	+1	# speculative_load                           [0]    [load_store_unit]
+0	0	+1	# nb_bypass_memory                           [0]    [load_store_unit]
+1	1	+1	# size_write_queue                           [0]    [write_unit]
+1	1	+1	# size_execute_queue                         [0]    [write_unit]
+1	1	+1	# nb_bypass_write                            [0]    [write_unit]
+1	1	+1	# nb_gpr_bank                                	    
+1	1	+1	# nb_gpr_port_read_by_bank                   	    
+1	1	+1	# nb_gpr_port_write_by_bank                  	    
+1	1	+1	# nb_spr_bank                                	    
+1	1	+1	# nb_spr_port_read_by_bank                   	    
+1	1	+1	# nb_spr_port_write_by_bank                  	    
+64	64	+1	# nb_general_register                        [0]    [nb_ooo_engine]		  
+16	16	+1	# nb_special_register                        [0]    [nb_ooo_engine]		  
+1	1	+1	# nb_inst_insert_rob                         [0]    [nb_ooo_engine]		  
+1	1	+1	# nb_inst_retire_rob                         [0]    [nb_ooo_engine]		  
+1	1	+1	# execution_unit_to_write_unit_priority                                      
+1	1	+1	# execution_unit_to_write_unit_table_routing [0][0] [nb_execute_unit][nb_write_unit]
+1	1	+1	# execution_unit_to_write_unit_table_routing [1][0] [nb_execute_unit][nb_write_unit]
+1	1	+1	# execution_unit_to_write_unit_table_thread  [0][0] [nb_write_unit][nb_thread]	  
+1	1	+1	# read_unit_to_execution_unit_priority                                       
+1	1	+1	# read_unit_to_execution_unit_table_routing  [0][0] [nb_read_unit][nb_execute_unit] 
+1	1	+1	# read_unit_to_execution_unit_table_routing  [0][1] [nb_read_unit][nb_execute_unit] 
+1	1	+1	# read_unit_to_execution_unit_table_thread   [0][0] [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [1][0] [nb_execute_unit][nb_thread]    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h	(revision 78)
@@ -0,0 +1,29 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test "RegisterFile"
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#include <string>
+#include <iostream>
+#include <sys/time.h>
+
+#include "Common/include/Time.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Execute_loop.h"
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural;
+using namespace morpheo::behavioural::core;
+using namespace morpheo::behavioural::core::multi_execute_loop;
+
+using namespace morpheo::behavioural::core::multi_execute_loop::execute_loop;
+
+void test    (string name,
+	      morpheo::behavioural::core::multi_execute_loop::execute_loop::Parameters * param);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 78)
@@ -0,0 +1,300 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h"
+
+#define NB_PARAMS 18
+
+void usage (int argc, char * argv[])
+{
+  err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
+  err (_("list_params is :\n"));
+  err (_(" * nb_read_unit                                                               (uint32_t           )\n"));
+  err (_(" * nb_functionnal_unit                                                        (uint32_t           )\n"));
+  err (_(" * nb_load_store_unit                                                         (uint32_t           )\n"));
+  err (_(" * nb_write_unit                                                              (uint32_t           )\n"));
+  err (_(" * nb_context                                                                 (uint32_t           )\n"));
+  err (_(" * nb_front_end                                                               (uint32_t           )\n"));
+  err (_(" * nb_ooo_engine                                                              (uint32_t           )\n"));
+  err (_(" * nb_packet                                                                  (uint32_t           )\n"));
+  err (_(" * size_general_data                                                          (uint32_t           )\n"));
+  err (_(" * size_special_data                                                          (uint32_t           )\n"));
+  err (_(" * size_read_queue                           [read_unit]                      (uint32_t           )\n"));
+  err (_(" * size_reservation_station                  [read_unit]                      (uint32_t           )\n"));
+  err (_(" * nb_inst_retire                            [read_unit]                      (uint32_t           )\n"));
+  err (_(" * size_store_queue                          [load_store_unit]                (uint32_t           )\n"));
+  err (_(" * size_load_queue                           [load_store_unit]                (uint32_t           )\n"));
+  err (_(" * size_speculative_access_queue             [load_store_unit]                (uint32_t           )\n"));
+  err (_(" * nb_port_check                             [load_store_unit]                (uint32_t           )\n"));
+  err (_(" * speculative_load                          [load_store_unit]                (Tspeculative_load_t)\n"));
+  err (_(" * nb_bypass_memory                          [load_store_unit]                (uint32_t           )\n"));
+  err (_(" * size_write_queue                          [write_unit]                     (uint32_t           )\n"));
+  err (_(" * size_execute_queue                        [write_unit]                     (uint32_t           )\n"));
+  err (_(" * nb_bypass_write                           [write_unit]                     (uint32_t           )\n"));
+  err (_(" * nb_gpr_bank                                                                (uint32_t           )\n"));
+  err (_(" * nb_gpr_port_read_by_bank                                                   (uint32_t           )\n"));
+  err (_(" * nb_gpr_port_write_by_bank                                                  (uint32_t           )\n"));
+  err (_(" * nb_spr_bank                                                                (uint32_t           )\n"));
+  err (_(" * nb_spr_port_read_by_bank                                                   (uint32_t           )\n"));
+  err (_(" * nb_spr_port_write_by_bank                                                  (uint32_t           )\n"));
+  err (_(" * nb_general_register                       [nb_ooo_engine]                  (uint32_t           )\n"));
+  err (_(" * nb_special_register                       [nb_ooo_engine]                  (uint32_t           )\n"));
+  err (_(" * nb_inst_insert_rob                        [nb_ooo_engine]                  (uint32_t           )\n"));
+  err (_(" * nb_inst_retire_rob                        [nb_ooo_engine]                  (uint32_t           )\n"));
+  err (_(" * execution_unit_to_write_unit_priority                                      (Tpriority_t        )\n"));
+  err (_(" * execution_unit_to_write_unit_table_routing[nb_execute_unit][nb_write_unit] (bool               )\n"));
+  err (_(" * execution_unit_to_write_unit_table_thread [nb_write_unit][nb_thread]       (bool               )\n"));
+  err (_(" * read_unit_to_execution_unit_priority                                       (Tpriority_t        )\n"));
+  err (_(" * read_unit_to_execution_unit_table_routing [nb_read_unit][nb_execute_unit]  (bool               )\n"));
+  err (_(" * read_unit_to_execution_unit_table_thread  [nb_execute_unit][nb_thread]     (bool               )\n"));
+
+  exit (1);
+}
+
+#ifndef SYSTEMC
+int main    (int argc, char * argv[])
+#else
+int sc_main (int argc, char * argv[])
+#endif
+{
+  if (argc < 2+NB_PARAMS)
+    usage (argc, argv);
+
+  uint32_t       x = 1;
+
+  string                name                =      argv[x++];
+  uint32_t              nb_read_unit        = atoi(argv[x++]);
+  uint32_t              nb_functionnal_unit = atoi(argv[x++]);
+  uint32_t              nb_load_store_unit  = atoi(argv[x++]);
+  uint32_t              nb_write_unit       = atoi(argv[x++]);
+  uint32_t              nb_context          = atoi(argv[x++]);
+  uint32_t              nb_front_end        = atoi(argv[x++]);
+  uint32_t              nb_ooo_engine       = atoi(argv[x++]);
+  uint32_t              nb_packet           = atoi(argv[x++]);
+  uint32_t              size_general_data   = atoi(argv[x++]);
+  uint32_t              size_special_data   = atoi(argv[x++]);
+
+  uint32_t nb_execute_unit = nb_functionnal_unit + nb_load_store_unit;
+  uint32_t nb_thread       = get_nb_thread(nb_context, nb_front_end, nb_ooo_engine);
+
+  int32_t nb_params = (2+NB_PARAMS+
+		       3*nb_read_unit+
+		       6*nb_load_store_unit+
+		       3*nb_write_unit+
+		       4*nb_ooo_engine+
+		       nb_execute_unit*nb_write_unit+
+		       nb_write_unit*nb_thread+
+		       nb_read_unit*nb_execute_unit+
+		       nb_execute_unit*nb_thread);
+  
+  
+  
+  if (argc != nb_params)
+    {
+      msg(_("Need %d parameters."),nb_params);
+      usage (argc, argv);
+    }
+  uint32_t            * size_read_queue          = new uint32_t [nb_read_unit];
+  for (uint32_t i=0; i<nb_read_unit; i++)
+    size_read_queue [i] = atoi(argv[x++]);
+
+  uint32_t            * size_reservation_station = new uint32_t [nb_read_unit];
+  for (uint32_t i=0; i<nb_read_unit; i++)
+    size_reservation_station [i] = atoi(argv[x++]);
+
+  uint32_t            * nb_inst_retire           = new uint32_t [nb_read_unit];
+  for (uint32_t i=0; i<nb_read_unit; i++)
+    nb_inst_retire [i] = atoi(argv[x++]);
+
+  uint32_t          * size_store_queue              = new uint32_t [nb_load_store_unit];
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    size_store_queue              [i] = atoi(argv[x++]);
+
+  uint32_t          * size_load_queue               = new uint32_t [nb_load_store_unit];
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    size_load_queue               [i] = atoi(argv[x++]);
+
+  uint32_t          * size_speculative_access_queue = new uint32_t [nb_load_store_unit];
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    size_speculative_access_queue [i] = atoi(argv[x++]);
+
+  uint32_t          * nb_port_check                 = new uint32_t [nb_load_store_unit];
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    nb_port_check                 [i] = atoi(argv[x++]);
+
+  Tspeculative_load_t * speculative_load            = new Tspeculative_load_t [nb_load_store_unit];
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    speculative_load              [i] = fromString<Tspeculative_load_t>(argv[x++]);
+
+  uint32_t          * nb_bypass_memory              = new uint32_t [nb_load_store_unit];
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    nb_bypass_memory              [i] = atoi(argv[x++]);
+
+  uint32_t * size_write_queue   = new uint32_t [nb_write_unit];
+  for (uint32_t i=0; i<nb_write_unit; i++)
+    size_write_queue   [i] = atoi(argv[x++]);
+  
+  uint32_t * size_execute_queue = new uint32_t [nb_write_unit];
+  for (uint32_t i=0; i<nb_write_unit; i++)
+    size_execute_queue [i] = atoi(argv[x++]);
+  
+  uint32_t * nb_bypass_write    = new uint32_t [nb_write_unit];
+  for (uint32_t i=0; i<nb_write_unit; i++)
+    nb_bypass_write    [i] = atoi(argv[x++]);
+
+  uint32_t nb_gpr_bank                = atoi(argv[x++]);
+  uint32_t nb_gpr_port_read_by_bank   = atoi(argv[x++]);
+  uint32_t nb_gpr_port_write_by_bank  = atoi(argv[x++]);
+  uint32_t nb_spr_bank                = atoi(argv[x++]);
+  uint32_t nb_spr_port_read_by_bank   = atoi(argv[x++]);
+  uint32_t nb_spr_port_write_by_bank  = atoi(argv[x++]);
+
+  uint32_t * nb_general_register = new uint32_t [nb_ooo_engine];
+  for (uint32_t i=0; i<nb_ooo_engine; i++)
+    nb_general_register [i] = atoi(argv[x++]);
+
+  uint32_t * nb_special_register = new uint32_t [nb_ooo_engine];
+  for (uint32_t i=0; i<nb_ooo_engine; i++)
+    nb_special_register [i] = atoi(argv[x++]);
+
+  uint32_t * nb_inst_insert_rob  = new uint32_t [nb_ooo_engine];
+  for (uint32_t i=0; i<nb_ooo_engine; i++)
+    nb_inst_insert_rob  [i] = atoi(argv[x++]);
+
+  uint32_t * nb_inst_retire_rob  = new uint32_t [nb_ooo_engine];
+  for (uint32_t i=0; i<nb_ooo_engine; i++)
+    nb_inst_retire_rob  [i] = atoi(argv[x++]);
+
+  Tpriority_t execution_unit_to_write_unit_priority = fromString<Tpriority_t>(argv[x++]);
+
+  bool ** execution_unit_to_write_unit_table_routing = new bool * [nb_execute_unit];
+  for (uint32_t i=0; i<nb_execute_unit; i++)
+    {
+      execution_unit_to_write_unit_table_routing [i] = new bool [nb_write_unit];
+      for (uint32_t j=0; j<nb_write_unit; j++)
+	execution_unit_to_write_unit_table_routing [i][j] = atoi(argv[x++]);
+    }
+  bool ** execution_unit_to_write_unit_table_thread = new bool * [nb_write_unit];
+  for (uint32_t i=0; i<nb_write_unit; i++)
+    {
+      execution_unit_to_write_unit_table_thread [i] = new bool [nb_thread];
+      for (uint32_t j=0; j<nb_thread; j++)
+	execution_unit_to_write_unit_table_thread  [i][j] = atoi(argv[x++]);
+    }
+  Tpriority_t read_unit_to_execution_unit_priority  = fromString<Tpriority_t>(argv[x++]);
+
+  bool ** read_unit_to_execution_unit_table_routing = new bool * [nb_read_unit];
+  for (uint32_t i=0; i<nb_read_unit; i++)
+    {
+      read_unit_to_execution_unit_table_routing [i] = new bool [nb_execute_unit];
+      for (uint32_t j=0; j<nb_execute_unit; j++)
+	read_unit_to_execution_unit_table_routing [i][j] = atoi(argv[x++]);
+    }
+  bool ** read_unit_to_execution_unit_table_thread = new bool * [nb_execute_unit];
+  for (uint32_t i=0; i<nb_execute_unit; i++)
+    {
+      read_unit_to_execution_unit_table_thread [i] = new bool [nb_thread];
+      for (uint32_t j=0; j<nb_thread; j++)
+	read_unit_to_execution_unit_table_thread [i][j] =  atoi(argv[x++]);
+    }
+  execute_timing_t *** timing = new execute_timing_t ** [nb_execute_unit];
+  
+  // alloc and reset timing array
+  for (uint32_t i=0; i< nb_execute_unit; i++)
+    {
+      timing [i] = new execute_timing_t * [MAX_TYPE];
+      
+      for (uint32_t j=0; j< MAX_TYPE; j++)
+	{
+	  timing [i][j]= new execute_timing_t [MAX_OPERATION];
+	  
+	  for (uint32_t k=0; k< MAX_OPERATION; k++)
+	    timing[i][j][k]._delay = timing[i][j][k]._latence = 0;
+	}
+    }
+  
+  for (uint32_t i=0; i< nb_load_store_unit; i++)
+    for (uint32_t k=0; k< MAX_OPERATION; k++)
+      timing[i][TYPE_MEMORY][k]._delay = timing[i][TYPE_MEMORY][k]._latence = 1;
+  for (uint32_t i=0; i< nb_functionnal_unit; i++)
+    for (uint32_t j=0; j< MAX_TYPE; j++)
+      if (j != TYPE_MEMORY)
+	for (uint32_t k=0; k< MAX_OPERATION; k++)
+	  timing[i+nb_load_store_unit][j][k]._delay = timing[i+nb_load_store_unit][j][k]._latence = 1;
+
+  morpheo::behavioural::custom::custom_information_t (*get_custom_information) (uint32_t) = &(morpheo::behavioural::custom::default_get_custom_information);
+
+  try 
+    {
+      morpheo::behavioural::core::multi_execute_loop::execute_loop::Parameters * param = new morpheo::behavioural::core::multi_execute_loop::execute_loop::Parameters
+	(nb_read_unit                                  ,
+	 nb_functionnal_unit                           ,
+	 nb_load_store_unit                            ,
+	 nb_write_unit                                 ,
+	 
+	 nb_context                                    ,
+	 nb_front_end                                  ,
+	 nb_ooo_engine                                 ,
+	 nb_packet                                     ,
+	 size_general_data                             ,
+	 size_special_data                             ,
+	 
+	 size_read_queue                               ,
+	 size_reservation_station                      ,
+	 nb_inst_retire                                ,
+	 
+	 timing                                        ,
+	 get_custom_information                        ,
+	 			
+	 size_store_queue                              ,
+	 size_load_queue                               ,
+	 size_speculative_access_queue                 ,
+	 nb_port_check                                 ,
+	 speculative_load                              ,
+	 
+	 nb_bypass_memory                              ,
+	 size_write_queue                              ,
+	 size_execute_queue                            ,
+	 nb_bypass_write                               ,
+	 
+	 nb_gpr_bank                                   ,
+	 nb_gpr_port_read_by_bank                      ,
+	 nb_gpr_port_write_by_bank                     ,
+	 nb_spr_bank                                   ,
+	 nb_spr_port_read_by_bank                      ,
+	 nb_spr_port_write_by_bank                     ,
+	 nb_general_register                           ,
+	 nb_special_register                           ,
+	 nb_inst_insert_rob                            ,
+	 nb_inst_retire_rob                            ,
+	 
+	 execution_unit_to_write_unit_priority         ,
+	 execution_unit_to_write_unit_table_routing    ,
+	 execution_unit_to_write_unit_table_thread     ,
+	 
+	 read_unit_to_execution_unit_priority          ,
+	 read_unit_to_execution_unit_table_routing     ,
+	 read_unit_to_execution_unit_table_thread      );
+      
+      msg(_("%s"),param->print(1).c_str());
+      
+      test (name,param);
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msg (_("<%s> : %s.\n"),name.c_str(), error.what ());
+      exit (EXIT_FAILURE);
+    }
+  catch (...)
+    {
+      err (_("<%s> : This test must generate a error.\n"),name.c_str());
+      exit (EXIT_FAILURE);
+    }
+
+  return (EXIT_SUCCESS);
+}
+
